# Generated by Django 3.2.12 on 2022-04-21 21:21

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ('relatorios', '0014_auto_20220503_0732'),
    ]

    operations = [
        # 1. TotaisGerais por Organização
        migrations.RunSQL(
            """
            DROP VIEW IF EXISTS relatorios_totaisgeraisorganizacao;
            CREATE OR REPLACE VIEW relatorios_totaisgeraisorganizacao AS
            SELECT row_number() OVER ()           AS id,
                   sum(a.qtd_territorios)  AS qtd_territorios,
                   sum(a.qtd_territorios_aprovados) AS qtd_territorios_aprovados,
                   sum(a.area_territorios) AS area_territorios,
                   sum(a.area_territorios_aprovados) AS area_territorios_aprovados,
                   sum(a.qtd_familias)     AS qtd_familias,
                   sum(a.qtd_familias_aprovadas)     AS qtd_familias_aprovadas,
                   sum(a.qtd_usuarios)     AS qtd_usuarios,
                   sum(a.qtd_areasdeuso)   AS qtd_areasdeuso,
                   sum(a.qtd_areasdeuso_aprovadas)   AS qtd_areasdeuso_aprovadas,
                   sum(a.qtd_conflitos)    AS qtd_conflitos,
                   sum(a.qtd_conflitos_aprovados)   AS qtd_conflitos_aprovados,
                   a.organizacao_id AS organizacao_id
            FROM (
                     SELECT count(t.id)                          AS qtd_territorios,
                            count(t.id)
                                FILTER (WHERE t.status_id = 4 OR t.status_id = 5)
                                AS qtd_territorios_aprovados,
                            sum(st_area(t.poligono::geography))  AS area_territorios,
                            sum(st_area(t.poligono::geography))
                                FILTER (WHERE t.status_id = 4 OR t.status_id = 5)
                                AS area_territorios_aprovados,
                            sum(qtde_familias)                   AS qtd_familias,
                            sum(qtde_familias)
                                FILTER (WHERE t.status_id = 4 OR t.status_id = 5)
                                AS qtd_familias_aprovadas,
                            0                                    AS qtd_usuarios,
                            0        AS qtd_areasdeuso,
                            0        AS qtd_areasdeuso_aprovadas,
                            0        AS qtd_conflitos,
                            0        AS qtd_conflitos_aprovados,
                            t.organizacao_id        AS organizacao_id
                     FROM main_territorio t
                     WHERE
                        t.deleted IS NULL AND
                        t.teste is false
		     GROUP BY organizacao_id
                     UNION
                     SELECT 0        AS qtd_territorios,
                            0        AS qtd_territorios_aprovados,
                            0        AS area_territorios,
                            0        AS area_territorios_aprovados,
                            0        AS qtd_familias,
                            0        AS qtd_familias_aprovadas,
                            count(u) AS qtd_usuarios,
                            0        AS qtd_areasdeuso,
                            0        AS qtd_areasdeuso_aprovadas,
                            0        AS qtd_conflitos,
                            0        AS qtd_conflitos_aprovados,
                            ou.organizacao_id        AS organizacao_id
                     FROM usuaria u INNER JOIN main_organizacaousuaria ou ON u.id=ou.usuaria_id
		     GROUP BY organizacao_id
                     UNION
                     SELECT 0        AS qtd_territorios,
                            0        AS qtd_territorios_aprovados,
                            0        AS area_territorios,
                            0        AS area_territorios_aprovados,
                            0        AS qtd_familias,
                            0        AS qtd_familias_aprovadas,
                            0        AS qtd_usuarios,
                            count(au.id) AS qtd_areasdeuso,
                            count(au.id)
                                FILTER (WHERE tt.status_id = 4 OR tt.status_id = 5)
                                AS qtd_areasdeuso_aprovadas,
                            0        AS qtd_conflitos,
                            0        AS qtd_conflitos_aprovados,
                            tt.organizacao_id        AS organizacao_id
                     FROM main_areadeuso au, main_territorio tt
                     WHERE
                        au.territorio_id = tt.id AND
                        tt.deleted IS NULL AND
                        tt.teste is false AND
                        au.deleted IS NULL
		     GROUP BY organizacao_id
                     UNION
                     SELECT 0           AS qtd_territorios,
                            0           AS qtd_territorios_aprovados,
                            0           AS area_territorios,
                            0           AS area_territorios_aprovados,
                            0           AS qtd_familias,
                            0           AS qtd_familias_aprovadas,
                            0           AS qtd_usuarios,
                            0           AS qtd_areasdeuso,
                            0           AS qtd_areasdeuso_aprovadas,
                            count(c.id) AS qtd_conflitos,
                            count(c.id)
                                FILTER (WHERE tt.status_id = 4 OR tt.status_id = 5)
                                AS qtd_conflitos_aprovados,
                            tt.organizacao_id        AS organizacao_id
                     FROM main_conflito c, main_territorio tt
                     WHERE
                        c.territorio_id = tt.id AND
                        tt.deleted IS NULL AND
                        tt.teste is false AND
                        c.deleted IS NULL
		     GROUP BY organizacao_id
            ) a GROUP BY organizacao_id
            """),
    ]
